Why is my Group deleted while trying to add entities to it?
-
@thomthom said:
Where in the script does the error occur?
I have updated the post to include the full error message.
@unknownuser said:
[off:56wfnlq5]Btw - you should wrap your plugin in a module in order to contain it to its own namespace.
Read more: http://www.thomthom.net/thoughts/2012/01/golden-rules-of-sketchup-plugin-development/[/off:56wfnlq5]Great, will look into that! And thanks for all your other tips as well .
-
Only ever use
entities.add_group(ents)
when 'entities' is the 'model.active_entities' and 'ents' are also in the 'model.active_entities'...
Something like...
frame_group = Sketchup.active_model.active_entities.add_group() for edge in edges frame_group.entities.add_group(self.create_strut(edge,center,size)) end
might be better... -
Error line doesn't match anything in the BitBucket repository...
-
I'm guessing it refer to line 58. I'm pretty sure it's because you make the containing group after you make the child entities. Refactor the code so you always create the container first - and then add the entities to the container.
-
@thomthom said:
Error line doesn't match anything in the BitBucket repository...
Sorry, the file was out of sync, yes. Corrected.
Looking into your suggestions now!
-
@thomthom said:
I'm guessing it refer to line 58. I'm pretty sure it's because you make the containing group after you make the child entities. Refactor the code so you always create the container first - and then add the entities to the container.
strut = create_strut edge, center, size frame_group.entities.add_group strut
I think you are onto something there. I just noticed that I am creating an extra group in that line, that I don't want or need. create_strut is already returning a group and I have used add_group strut to add that group to my frame_group but while doing that I am creating another group.
How do I add an existing entity (a group in this instance), to an existing group? I can't find any methods for that.
-
@tig said:
Only ever use
entities.add_group(ents)
when 'entities' is the 'model.active_entities' and 'ents' are also in the 'model.active_entities'...
Something like...
frame_group = Sketchup.active_model.active_entities.add_group() for edge in edges frame_group.entities.add_group(self.create_strut(edge,center,size)) end
might be better...Thanks TIG. Did not solve this problem but learning about 'active_entities' was very useful. Was wondering why my struts were being created outside the active component before..
-
Above:
delete line 44
change line 42 to:
create_strut edge, center, size, frame_group
change line 3 to:
def create_strut edge, center, size, frame_group
change line 4 to:
entities = frame_group.entities
-
@tiktuk said:
@thomthom said:
I'm guessing it refer to line 58. I'm pretty sure it's because you make the containing group after you make the child entities. Refactor the code so you always create the container first - and then add the entities to the container.
strut = create_strut edge, center, size frame_group.entities.add_group strut
I think you are onto something there. I just noticed that I am creating an extra group in that line, that I don't want or need. create_strut is already returning a group and I have used add_group strut to add that group to my frame_group but while doing that I am creating another group.
How do I add an existing entity (a group in this instance), to an existing group? I can't find any methods for that.
I'm not aware of any way to do this directly. If it's a group you want to add you can say:
new_group.entities.add_instance original_group.entities.parent
(original_group.entities.parent will give you the original group's definition, so you add it like you're adding a component instance)
as far as adding individual items to a group, you can do it this way, but it's a little iffy:
entities_i_want_to_add = [] #array of entities you want to add to the new group new_group = entities.add_group entities_i_want_to_add
then I guess you could find the definition of this new group and add it to whatever entities collection you want, then explode the original
The most foolproof way to add entities to a group is to add the raw geometry using Entities.add_edges and Entities.add_face. You'd also need to copy the materials and any attributes you wanted to go along with them.
-
As Karen said...
You can replicate the faces, edges etc inside a new group [erasing the originals if desired], but you ought to include all materials, layers, smoothed/softened/hidden-settings and attributes etc to make a perfect clone.
You can 'safely' usegroup=entities.add_group(array_of_stuff)
BUT only if the new group and all of the elements in the array are in the same 'context' AND that is the model.active_entities... you can check for that, or if for example you are working on a preselection you know that it is the active_entities, so this will work...
new_group=model.active_entities.add_group(model.selection.to_a)
Then you could 'move' that into any other group/component's entities by getting a reference to its definition [components, groups and images are each instances of variations of a 'definition'].
Let's assume you have another group called 'receiver_group'...
tr=Geom::Transformation.new() new_group_clone=receiver_group.entities.add_instance(new_group.entities.parent, tr)
So the selection has been grouped, that group has been cloned inside another group.To tidy up use
new_group.erase!
- you could also usenew_group_clone.explode
so the selection is loose inside the 'receiver_group'... -
Thanks everybody, this forum is splendid, got it working thanks to your explanations . Ended up just collecting the groups in an array an creating a group with that. Works perfectly.
<span class="syntaxdefault">def create_frame edges</span><span class="syntaxkeyword">, </span><span class="syntaxdefault">center</span><span class="syntaxkeyword">, </span><span class="syntaxdefault">size<br /> all_struts </span><span class="syntaxkeyword">= []<br /> </span><span class="syntaxdefault">edges</span><span class="syntaxkeyword">.</span><span class="syntaxdefault">each_with_index </span><span class="syntaxkeyword">{ | </span><span class="syntaxdefault">edge</span><span class="syntaxkeyword">, </span><span class="syntaxdefault">index </span><span class="syntaxkeyword">|<br /> </span><span class="syntaxdefault">strut </span><span class="syntaxkeyword">= </span><span class="syntaxdefault">create_strut edge</span><span class="syntaxkeyword">, </span><span class="syntaxdefault">center</span><span class="syntaxkeyword">, </span><span class="syntaxdefault">size<br /> props </span><span class="syntaxkeyword">= </span><span class="syntaxdefault">strut_properties edge</span><span class="syntaxkeyword">.</span><span class="syntaxdefault">length<br /> strut</span><span class="syntaxkeyword">.</span><span class="syntaxdefault">name </span><span class="syntaxkeyword">= </span><span class="syntaxdefault">props</span><span class="syntaxkeyword">[</span><span class="syntaxstring">"name"</span><span class="syntaxkeyword">]<br /> </span><span class="syntaxdefault">strut</span><span class="syntaxkeyword">.</span><span class="syntaxdefault">material </span><span class="syntaxkeyword">= </span><span class="syntaxdefault">props</span><span class="syntaxkeyword">[</span><span class="syntaxstring">"color"</span><span class="syntaxkeyword">]<br /> </span><span class="syntaxdefault">all_struts </span><span class="syntaxkeyword"><< </span><span class="syntaxdefault">strut<br /> </span><span class="syntaxkeyword">}<br /> </span><span class="syntaxdefault">frame_group </span><span class="syntaxkeyword">= </span><span class="syntaxdefault">Sketchup</span><span class="syntaxkeyword">.</span><span class="syntaxdefault">active_model</span><span class="syntaxkeyword">.</span><span class="syntaxdefault">active_entities</span><span class="syntaxkeyword">.</span><span class="syntaxdefault">add_group all_struts<br /> frame_group</span><span class="syntaxkeyword">.</span><span class="syntaxdefault">name </span><span class="syntaxkeyword">= </span><span class="syntaxstring">"Geodome frame"<br /></span><span class="syntaxdefault">end</span>
I see that your idea would work too, Dan, thanks!
-
@tiktuk said:
I see that your idea would work too, Dan, thanks!
Your welcome.
It is a normal way to pass the context into a method, that creates geometry, so that the method can create the geometry in any context (model or group or component.)
It makes your methods more flexible, so that they can be reused for multiple commands and plugins.
-
I second what Dan said.
When you model in SketchUp you draw then group.
When you use the API you make the group and then draw entities within that group. It's the clean and safe way of grouping. It's also faster, because you add the entities directly into the context where you want then. If you take existing geometry and group them it takes extra processing to move them.
-
@th3lurker said:
Also, even if you don't use it, group.add_faces_from_mesh and group.fill_from_mesh seem to delete everything existent in that group.
Only
group.fill_from_mesh
- as described in the API docs for the methods. -
Also, even if you don't use it, group.entities.add_faces_from_mesh and group.entities.fill_from_mesh seem to delete everything existent in that group.
Edit: thomthom corrected me, sorry. Also, i wrote group.fill_from_mesh instead of group.ENTITIES.fill_from_mesh.
I'm going to crawl back to my hole now, one post, two mistakes is quite embarrassing.
Advertisement